=== debian/changelog ===
maxima (5.37.2-9) unstable; urgency=medium

  * Bug fix: "maxima do not load the draw package.", thanks to Renato
    Alvarez Nodarse (Closes: #803251).  rework sys:*load-pathname* patch
  * do not rebuild docs, remove build-dep on texi2html
  * no xmaxima in menu
  * use dh_compress to compress Manual.ps.gz

 -- Camm Maguire <camm@debian.org>  Thu, 29 Oct 2015 19:20:13 +0000

maxima (5.37.2-8) unstable; urgency=medium

  * Bug fix: "FTBFS on mips64el", thanks to James Cowgill (Closes:
    #775728). Rebuild against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 28 Oct 2015 11:16:02 +0000

maxima (5.37.2-7) unstable; urgency=medium

  * build-dep latest gcl, fix FTBFS mips64el

 -- Camm Maguire <camm@debian.org>  Fri, 23 Oct 2015 11:25:04 +0000

maxima (5.37.2-6) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 16 Oct 2015 13:14:26 +0000

maxima (5.37.2-5) unstable; urgency=medium

  * build-dep latest gcl
  * remove strace/setarch diagnostics

 -- Camm Maguire <camm@debian.org>  Tue, 13 Oct 2015 17:16:32 +0000

maxima (5.37.2-4) unstable; urgency=medium

  * setarch diagnostic tool in debian/rules

 -- Camm Maguire <camm@debian.org>  Sun, 11 Oct 2015 16:26:36 +0000

maxima (5.37.2-3) unstable; urgency=medium

  * remove references to si:*load-pathname*
  * strace build diagnostic

 -- Camm Maguire <camm@debian.org>  Fri, 09 Oct 2015 20:55:01 +0000

maxima (5.37.2-2) unstable; urgency=medium

  * build-dep on latest gcl
  * remove obsolete compatability code in debian/rules

 -- Camm Maguire <camm@debian.org>  Fri, 09 Oct 2015 14:13:39 +0000

maxima (5.37.2-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Thu, 01 Oct 2015 16:28:16 +0000

maxima (5.37.1-4) unstable; urgency=medium

  * build-dep on latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 29 Sep 2015 21:39:16 +0000

maxima (5.37.1-3) unstable; urgency=medium

  * build-dep on latest gcl
  * Bug fix: "Precision issues", thanks to Julien Puydt (Closes: #777072).

 -- Camm Maguire <camm@debian.org>  Fri, 25 Sep 2015 16:26:23 +0000

maxima (5.37.1-2) unstable; urgency=medium

  * build-dep on python

 -- Camm Maguire <camm@debian.org>  Tue, 15 Sep 2015 18:38:33 +0000

maxima (5.37.1-1) unstable; urgency=medium

  * New upstream release
  * Bug fix: "looking for info documentation in the wrong location",
    thanks to Antonio Terceiro (Closes: #788430).
  * Bug fix: "Fails to build from a git repository", thanks to Tobias
    Hansen (Closes: #780315).

 -- Camm Maguire <camm@debian.org>  Tue, 15 Sep 2015 16:34:03 +0000

maxima (5.36.1-2) unstable; urgency=medium

  * Bug fix: "Embedded code copy with missing copyright", thanks to Maria
    Valentina Marin (Closes: #795056).  Build-dep system texi2html
  * newer standards

 -- Camm Maguire <camm@debian.org>  Mon, 07 Sep 2015 15:37:37 +0000
