=== debian/changelog ===
maxima (5.38.0-3) unstable; urgency=medium

  * consolidate patches
  * Bug fix: "FTBFS when built with dpkg-buildpackage -A (tests fail)",
    thanks to Santiago Vila (Closes: #816982).
  * Bug fix: "looking for info documentation in the wrong location
    (again)", thanks to Kyanos (Closes: #810578).
  * Bug fix: "info files not where maxima expects them", thanks to Sanjoy
    Mahajan (Closes: #815940).
  * Bug fix: "changelog.gz is more than ten years old", thanks to Igor
    Bogomazov (Closes: #820781).

 -- Camm Maguire <camm@debian.org>  Wed, 13 Apr 2016 14:49:57 +0000

maxima (5.38.0-2) unstable; urgency=medium

  * fix i386 test failure

 -- Camm Maguire <camm@debian.org>  Sun, 10 Apr 2016 03:34:54 +0000

maxima (5.38.0-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Wed, 06 Apr 2016 17:57:43 +0000

maxima (5.37.3-1) unstable; urgency=medium

  * New upstream release
  * Todo: simplify clean/restore/save rules by foregoing aclocal and automake

 -- Camm Maguire <camm@debian.org>  Tue, 17 Nov 2015 18:57:07 +0000
